//
// Program mierzy okres (czestotliwosc*) oraz wspolczynnik wypelnienia 
// sygnalu wejsciowego - fali prostokotnej (wejscie - linia A5).
// Okres - w CCR1, wypelnienie - w CCR2 timera TIM2.

#include <stdio.h>
#include "stm32f4xx.h"
#include "GLCD.h"

#define __FI       1                        		// Font Index
  #define __FONT_WIDTH  16
  #define __FONT_HEIGHT 24

void clock_config(void);

char tekst1[20];
char tekst2[20];

int main(void){ 

// --- inicjalizacja i konfiguracja wyswietlacza LCD ---
	
	GLCD_Initialize(); 
	GLCD_Clear(White);
	GLCD_SetBackColor(White);
  GLCD_SetTextColor(Black);

// --- konfiguracja peryferiow ---
	
  RCC->AHB1ENR |= (1<<0);       							// Wlacz "zegar" dla GPIOA.
	RCC->APB1ENR |= (1<<0);   									// Wlacz "zegar" dla TIM2.

	GPIOA->MODER |= (2<<2*5);										// Linia A5 - ALTERNATE FUNCTION AF1 TIM2 CH1.
	GPIOA->AFR[0] |= (1<<4*5);

// --- 2 --- 
// Ustal zakres pomiarowy i rozdzielczosc pomiaru.

//	TIM2->PSC	=															// Preskaler.
//	TIM2->ARR =															// Zakres zliczania [0,ARR].

// Konfiguracja timera w trybie PWM Input.

	TIM2->CCMR1 |= (2<<8)| 1; 									// Mapowanie sygnalow: TI1->IC2, TI1->IC1.
	
	TIM2->SMCR |= (5<<4) | 4;										// Bity SMS=100 - Slave Reset Mode.
																							// Bity TS =101 - Trigger Selection - Timer Input 1.
// --- 1 ---
// Capture/Compare Enable Register
// Wlacz: kanal 1. i 2.
// Ustaw:
// kanal pierwszy - reakcja na zbocze rosnace (okres),
// kanal drugi - reakcja na zbocze opdadajace (wypelnienie).

//	TIM2->CCER =
																							
  TIM2->CR1 |= 1;															// Wlacz licznik.
	
	for(;;) {
				sprintf(tekst1,"Period = %u ms      ",TIM2->CCR1);
				GLCD_DisplayString(1, 0, __FI,tekst1);
				sprintf(tekst2,"Duty   = %u ms      ",TIM2->CCR2);
				GLCD_DisplayString(3, 0, __FI,tekst2);
	}
} 
